/*
Copyright Renaud GICQUEL 2005  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import extThopt.*;
import java.util.*; 
import java.awt.*; 
import javax.swing.*;

/**
 * classe de couplage du module SOFC aval
 * 
 * @author Renaud GICQUEL
 */
public class SOFCH2ElecOutlet extends ExtDivider implements Inversable
{
    
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField A_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField I_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField Q_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField Current_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField Tout_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel11 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel12 = new javax.swing.JLabel();
	javax.swing.JTextField Ncell_value = new javax.swing.JTextField();
    
    double Tamont, Taval, Pamont, Paval,P;
    String linkProcess,outletFuelProcess,outletAirProcess,outletAirSubstanceName,outletFuelSubstanceName;
    String linkPoint,outletFuelPoint,outletAirPoint;
    rg.corps.Corps outletAirSubstance;
    rg.corps.Corps outletFuelSubstance;
    double flowAirPauvre,flowOutFuel;
    
    SOFCH2ElecInlet inletSOFC;//module SOFC amont
    String inletSOFCName="";
    
    String[]gasComp={"H2","H2O"};
    double[]molMass={2.01588,18.01528};
    
    Vector fuelComp;
    Vector airComp;
    double epsi,tau;
    
    public SOFCH2ElecOutlet (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,600,150);
		JLabel1.setText("current intensity (A)");
		JLabel1.setForeground(Color.blue);
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,0,180,20);
		JPanel1.add(I_value);
		I_value.setBounds(180,0,124,20);
		I_value.setText("0.5");
		JLabel2.setText("active surface (cm2)");
		JLabel2.setForeground(Color.blue);
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,24,180,20);
		JPanel1.add(A_value);
		A_value.setBounds(180,24,124,20);
		A_value.setText("0.5");
		JLabel3.setText("heat released (W)");
		JPanel1.add(JLabel3);
		JLabel3.setBounds(0,48,180,20);
		JPanel1.add(Q_value);
		Q_value.setBounds(180,48,124,20);
		Q_value.setText("0");
		JLabel4.setText("electric power generated (W)");
		JPanel1.add(JLabel4);
		JLabel4.setBounds(0,72,180,20);
		JPanel1.add(Current_value);
		Current_value.setBounds(180,72,124,20);
		Current_value.setText("0");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,96,180,20);
		JLabel5.setText("outlet temperature (K)");
		JPanel1.add(Tout_value);
		Tout_value.setBounds(180,96,124,20);
		Tout_value.setText("0");
		type=getCompType();
		thermoCouplerTypes=new String[0];
		JLabel11.setText("conversion efficiency");
		JPanel1.add(JLabel11);
		JLabel11.setBounds(400,48,300,20);
		JLabel10.setText("fuel use rate");
		JPanel1.add(JLabel10);
		JLabel10.setBounds(400,24,300,20);
		JLabel9.setBounds(400,72,300,20);
		JLabel9.setText("voltage");
		JPanel1.add(JLabel9);
		JLabel12.setText("Number of cells");
		JLabel12.setForeground(Color.blue);
		JPanel1.add(JLabel12);
		JLabel12.setBounds(400,0,100,20);
		JPanel1.add(Ncell_value);
		Ncell_value.setBounds(500,0,124,20);
		Ncell_value.setText("200");
		
    }
    public void init(){
	    getDividerStructure();
        checkConsistency();
		setupInletSOFC();
    }
    
    public String getCompType(){
        return "SOFC H2 elec outlet";
    }
    
	public String getClassDescription(){
	    return "SOFC fuel cell model\noutlet divider\nno thermocoupler\n\nauthor : R. Gicquel april 2003\n\nRef : archive SOFCH2InletOutlet.zip";
	}
    
	public void calculateProcess(){
	
	    getDividerStructure();
        checkConsistency();
        if(inletSOFC==null)setupInletSOFC();
	    inletSOFC.calculateProcess();
	    
	    if((isBuilt)&&(inletSOFC.isBuilt)){//si les deux noeuds externes sont bien configurs
	        
	        airComp=inletSOFC.inputAirComp;//les gaz amont et aval ont la mme composition
	        fuelComp=initGasComp(gasComp,molMass);
	        
            //dbit molaire de H2
            double molFlowH2=inletSOFC.fuelFlow/molMass[0];
            //nombre de moles d'oxygne initial
            double xO2=inletSOFC.fractO2;
            double airMolFlow=inletSOFC.airFlow/inletSOFC.airM;
            
            double O2MolFlow=airMolFlow*xO2;
            double lambda=O2MolFlow/molFlowH2;
            System.out.println("molFlowH2 : "+molFlowH2+"  airMolFlow : "+airMolFlow+"  O2MolFlow : "+O2MolFlow);
                        
                        
                        
            double A=Util.lit_d(A_value.getText());//cm2
            double intens=Util.lit_d(I_value.getText());//A
        	double Ncell=Util.lit_d(Ncell_value.getText());
            
        	//Modle lectrique de Albrieux/Busquet/Hubert electric model
        	// 4 coefficients (function of T and pH2)
        	// modle d'ordre 1 (indpendance des 4 paramtres vis  vis de T et p)
        	// first order model (4 parameters independent of T and p)
        	double E = 0.94;
        	double b = 0.63;
        	double Jd = 400.;
        	double delta =0.0002;
	        //enthalpie de raction (PCI)  25 (ngative car exothermique)
	        //enthalpy of reaction (LHV) at 25 (negative as exothermal)
	        double DH0=-241830;        	
        	
        	double densCourant = 1000*intens/A; //mA/cm2
        	
        	double tensionCell = E+b/(Math.log(densCourant/Jd)-2)+densCourant*(b/4/Jd-delta);
        	
        	double Vtot = tensionCell*Ncell;
        	        	
		    JLabel9.setText("voltage : "+Util.aff_d(Vtot,3));
            tau=intens/A*1.2;         
        	JLabel10.setText("fuel use rate : "+Util.aff_d(tau,3));
                        
            //nombre de moles du fuel en sortie            
            double xH2=1-tau;
            double xH2O=tau;
            
            Util.updateMolarComp(fuelComp,gasComp[0], xH2);
            Util.updateMolarComp(fuelComp,gasComp[1], xH2O);
            
            outletFuelSubstance.updateGasComposition(fuelComp);
          
            double molFlow=molFlowH2*tau;
            
            //dbit molaire d'O2 consomm
            double O2conso=molFlow/2.;
            
            //dbit restant d'O2
            double O2restant=O2MolFlow-O2conso;
            System.out.println("O2MolFlow : "+O2MolFlow+"  O2conso : "+O2conso+"  O2restant : "+O2restant);
            
            
            //fraction du O2 initial utilis
            double epsiO2=(xO2-O2restant/airMolFlow)/xO2;
            System.out.println("epsiO2 : "+epsiO2);
	        for(int i=0;i<inletSOFC.inletAirFractmol.length;i++){//mise  jour des fractions molaire de sortie
	            double x_out=inletSOFC.inletAirFractmol[i]/(1-epsiO2*xO2);
	            Util.updateMolarComp(airComp,inletSOFC.inletAirComp[i], x_out);
	        }
            double xO2_out=(1-epsiO2)*xO2/(1-epsiO2*xO2);//fraction molaire de sortie en CO2
            System.out.println("xO2_out : "+xO2_out);
	        Util.updateMolarComp(airComp,"O2", xO2_out);
            outletAirSubstance.updateGasComposition(airComp);
            
            //calcul des dbits massiques en sortie
            double volFlowAirPauvre=airMolFlow*inletSOFC.airM-O2conso*32;
            System.out.println("volFlowAirPauvre : "+volFlowAirPauvre);
            
            getPointProperties(outletAirPoint);
            getSubstProperties(nomCorps);
            double outAirM=Msubst;//masse molaire du gaz  traiter            
            flowAirPauvre=volFlowAirPauvre;//*outAirM;
            System.out.println("outAirM : "+outAirM);
            
 
            double volFlowOutFuel=inletSOFC.fuelFlow+O2conso*32;
            getPointProperties(outletFuelPoint);
            getSubstProperties(nomCorps);
            double outFuelM=Msubst;//masse molaire du gaz  traiter
            System.out.println("outFuelM : "+outFuelM);
            
            flowOutFuel=volFlowOutFuel;//*outFuelM;

	        double totalFlow=flowAirPauvre+flowOutFuel;
	        
        	double current = -Vtot*intens;
        	double Qlib= -DH0*tau*molFlowH2+current;
        	
        	epsi = -current/(-DH0*tau*molFlowH2);
        	JLabel11.setText("conversion efficiency : "+Util.aff_d(epsi,3));
            
            Q_value.setText(Util.aff_d(Qlib,0));
            Current_value.setText(Util.aff_d(current,0));
                        
	        
            System.out.println("Qlib : "+Qlib+"  current : "+current);
            Q_value.setText(Util.aff_d(Qlib,2));
            Current_value.setText(Util.aff_d(current,2));
            
            double Htot=(inletSOFC.Htot+Qlib);///totalFlow;
            System.out.println("Htot : "+Htot);
            Taval=Util.dicho_T(this, 0, Htot, "outletTemp", inletSOFC.TamontAir, 2600, 0.01);
            Tout_value.setText(Util.aff_d(Taval,2));
	        
	        //mise  jour du noeud en utilisant les mthodes gnriques
	        vTransfo= new Vector[nBranches+1];
	        vPoints= new Vector[nBranches+1];
	        setupVector(outletFuelProcess, outletFuelPoint, 0, flowOutFuel, Taval, 1, 0);
	        setupVector(outletAirProcess, outletAirPoint, 1, flowAirPauvre, Taval, inletSOFC.PamontAir, 0);
	        setupVector(linkProcess, linkPoint, 2, totalFlow, Taval, inletSOFC.PamontAir, 0);
            updateDivider(vTransfo,vPoints,Taval,Htot/(inletSOFC.airFlow+inletSOFC.fuelFlow));
	        de.updateProcess(setEnergyTypes(linkProcess,current,-DH0*epsi*molFlowH2,0));
            
        }

    }
	
    public Vector initGasComp(String[]gasComp,double[]molMass){
        int nb_comp=gasComp.length;
        Vector vComp=new Vector();
        Double[]fracMol= new Double[nb_comp],fracMass= new Double[nb_comp],molarMass= new Double[nb_comp];
        for(int j=0;j<nb_comp;j++){
	        fracMol[j]=new Double(0);
	        fracMass[j]=new Double(0);
	        molarMass[j]=new Double(molMass[j]);
        }
        vComp.addElement(new Integer(nb_comp));
        vComp.addElement(gasComp);
        vComp.addElement(fracMol);
        vComp.addElement(fracMass);
        vComp.addElement(molarMass);
        return vComp;
    }
	
    
    private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[2];
        isBuilt=true;
        outletFuelProcess="";
        outletAirProcess="";
        if(nBranches!=2){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 3";
	        JOptionPane.showMessageDialog(de, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String amont=(String)vBranch[j].elementAt(1);//gets the upstream point name
	            getPointProperties(amont);//direct parsing of point property vector
                getSubstProperties(nomCorps);
                if(typeSubst==3){//le corps d'entre est un gaz pur

                    String nom=nomCorps;
                    //Check the substance at inlet
                    System.out.println(" ligne "+j+" nomCorps "+nomCorps);
	                if(nom.equals("O2")){
	                    outletFuelProcess=nomBranche[j];
	                    outletFuelPoint=amont;
	                }
	            }
                else if(typeSubst==4){//le corps d'entre est un gaz compos
                    Vector vComp=lecorps.getGasComposition();
                    System.out.println(" nbElements "+vComp.elementAt(0));

	                if(Util.contains(vComp,"N2")){
	                    outletAirProcess=nomBranche[j];
	                    outletAirPoint=amont;
                        args=new String[2];
                        args[0]="process";//type of the element (see method getProperties(String[] args))
                        args[1]=outletAirProcess;//name of the process (see method getProperties(String[] args))
                        Vector vProp=proj.getProperties(args);
                        amont=(String)vProp.elementAt(1);//gets the upstream point name
                        getPointProperties(amont);//direct parsing of point property vector
	                    outletAirSubstance=lecorps;
	                    outletAirSubstanceName=nomCorps;
	                }
	                else{
	                    outletFuelProcess=nomBranche[j];
	                    outletFuelPoint=amont;
                        args=new String[2];
                        args[0]="process";//type of the element (see method getProperties(String[] args))
                        args[1]=outletFuelProcess;//name of the process (see method getProperties(String[] args))
                        Vector vProp=proj.getProperties(args);
                        amont=(String)vProp.elementAt(1);//gets the upstream point name
                        getPointProperties(amont);//direct parsing of point property vector
	                    outletFuelSubstance=lecorps;
	                    outletFuelSubstanceName=nomCorps;
	                }
                }
	            else{//le corps d'entre n'est pas un gaz
	                String msg = "Error: the outlet substance is not a gas";
	                JOptionPane.showMessageDialog(de, msg);  
	            }
	        }
	        if((outletFuelProcess.equals(""))||(outletAirProcess.equals(""))){
	            String msg = "Error on at least one of the branch substances";
	            JOptionPane.showMessageDialog(de, msg);  
	            isBuilt=false;
	        }
        }
        linkProcess=mainProcess;
	    args[0]="process";//type of the element (see method getProperties(String[] args))
	    args[1]=linkProcess;//name of the process (see method getProperties(String[] args))
	    Vector vPropMain=proj.getProperties(args);
	    String aval=(String)vPropMain.elementAt(2);//gets the downstream point name
	    getPointProperties(aval);//direct parsing of point property vector
	    linkPoint=aval;
        String nom=nomCorps;
        
    }

	public void readCompParameters(String ligne_data){
        String valeur=Util.extr_value(ligne_data, "A_value");
        if(valeur!=null)epsi=Util.lit_d(valeur);
	    A_value.setText(Util.aff_d(epsi,3));
        valeur=Util.extr_value(ligne_data, "I_value");
        if(valeur!=null)I_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "Ncell_value");
        if(valeur!=null)Ncell_value.setText(valeur);
		double Tout=Util.lit_d(Util.extr_value(ligne_data, "Tout_value"));
	    Tout_value.setText(Util.aff_d(Tout,2));
		double Q=Util.lit_d(Util.extr_value(ligne_data, "Q_value"));
	    Q_value.setText(Util.aff_d(Q,2));
		double current=Util.lit_d(Util.extr_value(ligne_data, "Current_value"));
	    Current_value.setText(Util.aff_d(current,2));
	}
	
    public String saveCompParameters(){
	    String h="";
	    h=h
	    +"A_value="+A_value.getText()+tab
	    +"I_value="+I_value.getText()+tab
	    +"Ncell_value="+Ncell_value.getText()+tab
	    +"Tout_value="+Tout_value.getText()+tab
	    +"Q_value="+Q_value.getText()+tab
	    +"Current_value="+Current_value.getText()+tab
	    ;
        return h;
    }
    public double f_dicho(double T, double Htot,String fonc){
        if (fonc.equals("outletTemp")){
            double diff;
            Tpoint=T;
	        outletFuelSubstance.CalcPropCorps(T,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
            getSubstProperties(outletFuelSubstanceName);
            double Hfuel=Hsubst;
	        outletAirSubstance.CalcPropCorps(T,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
            getSubstProperties(outletAirSubstanceName);
            diff=Htot-flowOutFuel*Hfuel-flowAirPauvre*Hsubst;
            return diff;
        }
        return 0;
    }
 
    void setupInletSOFC(){
        Vector vExt=proj.getExternalClassInstances();
        for(int i=0;i<vExt.size();i++){
            Object[] obj=new Object[6];
	        obj=(Object[])vExt.elementAt(i);
	        String type=(String)obj[0];
	        if(type.equals("node")){
	            String main=(String)obj[4];
	            String nodeType=(String)obj[3];
	            if((main.equals(linkProcess))&&((nodeType.equals("SOFC H2 elec inlet")))){
	                inletSOFC=(SOFCH2ElecInlet)obj[1];
	                inletSOFCName=(String)obj[2];
                    System.out.println("inletSOFC : "+inletSOFC+"  inletAirProcess : "+inletSOFC.inletAirProcess);
	            }
	        }
        }
  }

}